//
//  BSArrayDebugObject.m
//  XcodeInspectors
//
//  Created by Karsten Kusche on 23.02.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "BSArrayDebugObject.h"


@implementation NSArray (BSDebugExtension)

+ (Class)debuggerObjectClass
{
	// arrays are represented by BSArrayDebugObjects
	return [BSArrayDebugObject class];
}

@end

@implementation BSArrayDebugObject

- (id)initWithCoder:(NSCoder*)decoder
{
	// use the super implementation and also decode the targetObject
	self = [super initWithCoder:decoder];
	targetObject = [[decoder decodeObjectForKey:@"targetObject"] retain];
	return self;
}

- (void)_encodeWithCoder:(NSCoder*)encoder
{
	// encode the array through a new array of debug-objects
	NSMutableArray* newArray = [NSMutableArray array];
	int i;
	int count = [targetObject count];
	for (i = 0; i < count; i++)
	{
		[newArray addObject:[BSDebugObject debugObjectWith:[targetObject objectAtIndex:i]]];
	}
	[encoder encodeObject:newArray forKey:@"targetObject"];
}

@end
