//
//  BSDebugLoader.m
//  XcodeInspectors
//
//  Created by Karsten Kusche on 03.02.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "BSDebugLoader.h"

@implementation BSDebugLoader

+ (int)loadPluginsAtPath:aPath
{
	// try to load the plugins that are available at the given folder
	
	int bundleCount = 0;
	NSArray* pluginFiles = [[NSFileManager defaultManager] directoryContentsAtPath:aPath];
	if (pluginFiles == nil) return 0; // folder doesn't exist
	NSEnumerator* plugins = [pluginFiles objectEnumerator];
	NSString* plugin;
	while (plugin = [plugins nextObject])
	{
		if ([[plugin pathExtension] isEqual:@"bsDebugObject"])
		{
			// principalClass returns the principal class, and loads the bundle if it's not loaded already
			Class bundleClass = [[NSBundle bundleWithPath:[aPath stringByAppendingPathComponent:plugin]] principalClass];
			if (bundleClass)
			{
				bundleCount ++;
//				NSLog(@"loaded DebugObject-bundle: %@",[aPath stringByAppendingPathComponent:plugin]);
			}
		}
	}
	return bundleCount;
}

+ (void)load
{
	// called when the bundle is loaded
	// it'll load all available plugins from the (~)/Library/Application Support/BSInspectors folders
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	NSArray* pluginFolders = [NSArray arrayWithObjects:@"~/Library/Application Support/BSInspectors",@"/Library/Application Support/BSInspectors",nil];
	NSEnumerator* folders = [pluginFolders objectEnumerator];
	NSString* aPath;
	int bundleCount = 0;
	while (aPath = [folders nextObject])
	{
		bundleCount += [self loadPluginsAtPath:[aPath stringByExpandingTildeInPath]];
	}	
	NSLog(@"########   debug data loaded for %@ with %i plugins   ########",[[NSProcessInfo processInfo] processName],bundleCount);
	[pool release];
}
@end
