//
//  BSDictionaryDebugObject.m
//  XcodeInspectors
//
//  Created by Karsten Kusche on 28.02.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "BSDictionaryDebugObject.h"

@implementation NSDictionary (BSDebugExtension)

+ (Class)debuggerObjectClass
{
	// Dictionaries are encoded using the BSDictionaryDebugObject class
	return [BSDictionaryDebugObject class];
}

@end

@implementation BSDictionaryDebugObject

- (void)_encodeWithCoder:(NSCoder*)encoder
{
	// dictionaries have strings as keys and some objects as values, so only the values need to be encoded as debug-objects
	// this method will create a new dictionary with the keys and debug-objects as values. this dictionary is then encoded.
	// maybe apple will remove this limitation of strings for keys once :-)
	
	// decoding is done like BSArrayDebugObject, cause it's only to decode the targetObject
	NSMutableDictionary* newDict = [NSMutableDictionary dictionary];
	int i;
	NSArray* keys = [targetObject allKeys];
	int count = [keys count];
	NSString* key;
	for (i = 0; i < count; i++)
	{
		key = [keys objectAtIndex: i];
		[newDict setObject:[BSDebugObject debugObjectWith:[targetObject objectForKey:key]] forKey:key];
	}
	[encoder encodeObject:newDict forKey:@"targetObject"];
}

@end
