//
//  BSImageDebugObject.m
//  XcodeInspectors
//
//  Created by Karsten Kusche on 02.03.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "BSImageDebugObject.h"


@implementation NSImage (BSDebugExtension)

+ (Class)debuggerObjectClass
{
	// Images are represented by BSImageDebugObjects
	return [BSImageDebugObject class];
}

@end

@implementation BSImageDebugObject

- (void)_encodeWithCoder:(NSCoder*)encoder
{
	// the image's data is encoded
	NSData* imageData = [(NSImage*)targetObject TIFFRepresentation];
	if (imageData)
	{
		[encoder encodeObject:imageData forKey:@"targetObject"];
	}
}

- (id)initWithCoder:(NSCoder*)decoder
{
	// the targetObject is missing from the super initialization, so decode it here
	if (self = [super initWithCoder:decoder])
	{
		targetObject = [[decoder decodeObjectForKey:@"targetObject"] retain];
	}
	return self;
}

@end
