//
//  BSImageInspector.m
//  XcodeInspectors
//
//  Created by Karsten Kusche on 02.03.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "BSImageInspector.h"
#import "BSImageDebugObject.h"

@implementation BSImageDebugObject (InspectorClassName)

+ (Class)inspectorClass
{
	// BSImageDebugObjects are inspected with a BSImageInspector object
	return [BSImageInspector class];
}

@end

@implementation BSImageInspector

- (NSString*)nibName
{
	// the name of the nib-file to load
	return @"ImageInspector";
}

- (void)awakeFromNib
{
	// super initializes the string inspector and if the targetObject is present, 
	// then the imageView will also display some funky graphics
	[super awakeFromNib];
	if ([debugObject targetObject])
	{
		[imageView setImage:[[NSImage alloc] initWithData:[debugObject targetObject]]];
	}
}
@end
