//
//  DebuggerHool.m
//  XcodeInspectors
//
//  Created by Karsten Kusche on 31.01.07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "DebuggerHook.h"
#import "GDB_AdapterExtension.h"

@implementation PBXDebugStackFrameViewModule (BSDebuggerHook)


- (void)inspectValue:(id)sender
{
	// this is the replacement method for the original implementation.
	// it is called when the variable is double-clicked
	if ([[NSApp currentEvent] modifierFlags] & NSAlternateKeyMask) 
	{
		// use the original implementation, when the option-key is pressed
		[self inspectValue: sender];
		return;
	}
	
	NSArray* selectedValues = [self selectedDataValues];
	PBXGDB_VarObjDataValue2* obj = [selectedValues lastObject];
	if ([obj canPrintDescription])
	{
		// the stringValue of obj returns the pointer string of an object (like @"0x1234")
		NSString* targetPointerStr = [obj stringValue];
		if (targetPointerStr)
		{
			// tell the debugger to open a new inspector
			[[[self model] debugger] requestBSDebugDataFor:targetPointerStr];
		}
		else
		{
			// this should probably never happen
			NSLog(@"no targetPointerString");
		}
//		NSLog(@"#######################");
	}
}
@end
